# order.shipping_and_tax

> This retrieves a shopper's shipping options and tax calculations for a given order.

Source: https://help.boltapp.com/api-reference/merchant-callback-reference/order/order-shipping-and-tax

`POST /order_shipping_and_tax`

## OpenAPI definition

This endpoint as it appears in the OpenAPI document, with every schema it references included.

```json
{
  "openapi": "3.2.0",
  "info": {
    "version": "1.0.0",
    "title": "Merchant Callback API Reference",
    "description": "## About\nThe Merchant Callback API is a general endpoint on your eCommerce server that Bolt calls to receive information necessary for operating the checkout process.\n\n**Note**: You must also reference the [Bolt API](/api-bolt) when building a custom cart integration.\n\n### URL Options\nYou can set the URL(s) for your Merchant Callback API in the [Bolt Merchant dashboard](https://merchant.boltapp.com).\n- **v1**: v1 endpoints are individualized and described in the subsections below with unique URLs (e.g., `/order_shipping_and_tax`)\n- **Universal**: The \"Universal API\" is one endpoint (instead of many) that handles all events described in this spec; the methods and payloads are identical, however you only need to use one URL.\n\nNeed more information? See our [Developer reference articles](/developers/references/) for **environment details**, **error codes**, and more.\n"
  },
  "servers": [
    {
      "url": "https://merchant-url.com/api"
    }
  ],
  "paths": {
    "/order_shipping_and_tax": {
      "post": {
        "summary": "order.shipping_and_tax",
        "operationId": "order.shipping_and_tax",
        "description": "This retrieves a shopper's shipping options and tax calculations for a given order.\n",
        "security": [
          {
            "ApiKeyAuth": [
              "X-API-Key"
            ]
          }
        ],
        "tags": [
          "Order"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/bolt_hmac_param"
          }
        ],
        "requestBody": {
          "$ref": "#/components/requestBodies/order_shipping_and_tax"
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/order_shipping_and_tax"
          },
          "422": {
            "$ref": "#/components/responses/order_shipping_and_tax_error"
          }
        }
      }
    }
  },
  "components": {
    "parameters": {
      "bolt_hmac_param": {
        "in": "header",
        "name": "X-Bolt-Hmac-Sha256",
        "schema": {
          "type": "string"
        },
        "description": "Bolt sends a signed HMAC for hook verification"
      }
    },
    "requestBodies": {
      "order_shipping_and_tax": {
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "event": {
                  "type": "string",
                  "enum": [
                    "order.shipping_and_tax"
                  ]
                },
                "data": {
                  "type": "object",
                  "description": "This is a generic wrapper for the merchant's data. Open to see properties.",
                  "properties": {
                    "shipping_address": {
                      "$ref": "#/components/schemas/shipping_address"
                    },
                    "cart": {
                      "$ref": "#/components/schemas/cart_shipment_combined"
                    },
                    "request_source": {
                      "$ref": "#/components/schemas/request_source"
                    },
                    "shipping_option": {
                      "$ref": "#/components/schemas/shipping_option"
                    },
                    "pickup_option": {
                      "$ref": "#/components/schemas/pickup_option"
                    },
                    "ship_to_store_option": {
                      "$ref": "#/components/schemas/shipping_to_store_option"
                    },
                    "metadata": {
                      "$ref": "#/components/schemas/metadata_component"
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "schemas": {
      "shipping_address": {
        "type": "object",
        "properties": {
          "id": {
            "$ref": "#/components/schemas/shipping_address_id"
          },
          "street_address1": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address2": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address3": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address4": {
            "$ref": "#/components/schemas/street_address"
          },
          "locality": {
            "$ref": "#/components/schemas/locality"
          },
          "region": {
            "$ref": "#/components/schemas/region"
          },
          "postal_code": {
            "$ref": "#/components/schemas/postal_code"
          },
          "country_code": {
            "$ref": "#/components/schemas/country_code"
          },
          "country": {
            "$ref": "#/components/schemas/country"
          },
          "name": {
            "$ref": "#/components/schemas/name_person"
          },
          "first_name": {
            "$ref": "#/components/schemas/first_name"
          },
          "last_name": {
            "$ref": "#/components/schemas/last_name"
          },
          "company": {
            "$ref": "#/components/schemas/company"
          },
          "phone": {
            "$ref": "#/components/schemas/phone"
          },
          "email": {
            "$ref": "#/components/schemas/email"
          }
        }
      },
      "shipping_address_id": {
        "type": "string",
        "description": "ID for billing address",
        "examples": [
          "addres-1"
        ]
      },
      "street_address": {
        "type": "string",
        "description": "You can use up to 4 street address fields.",
        "examples": [
          "42 Wallaby Way"
        ]
      },
      "locality": {
        "type": "string",
        "description": "A locale such as county, district, etc.",
        "examples": [
          "Wayne County"
        ]
      },
      "region": {
        "type": "string",
        "description": "A state, province, or similar region type.",
        "examples": [
          "Quebec"
        ]
      },
      "postal_code": {
        "type": "string",
        "description": "The postal code.",
        "examples": [
          "11209"
        ]
      },
      "country_code": {
        "type": "string",
        "description": "The 2-digit country code.",
        "examples": [
          "US"
        ]
      },
      "country": {
        "type": "string",
        "description": "The country's name.",
        "examples": [
          "Canada"
        ]
      },
      "name_person": {
        "type": "string",
        "description": "The first and last name together as a string.",
        "examples": [
          "Charlotte Charles"
        ]
      },
      "first_name": {
        "type": "string",
        "description": "The person's first name.",
        "examples": [
          "Charlotte"
        ]
      },
      "last_name": {
        "type": "string",
        "description": "The person's last name.",
        "examples": [
          "Charles"
        ]
      },
      "company": {
        "type": "string",
        "description": "The company's name",
        "examples": [
          "ACME Corp."
        ]
      },
      "phone": {
        "type": "string",
        "description": "A phone number without the country code.",
        "examples": [
          "867-5309"
        ]
      },
      "email": {
        "type": "string",
        "description": "The person's email address.",
        "examples": [
          "my.email@gmail.com"
        ]
      },
      "cart_shipment_combined": {
        "type": "object",
        "description": "A cart that is being prepared for shipment",
        "properties": {
          "items": {
            "$ref": "#/components/schemas/items"
          },
          "currency": {
            "$ref": "#/components/schemas/currency_iso"
          },
          "total_amount": {
            "$ref": "#/components/schemas/total_amount"
          },
          "display_id": {
            "$ref": "#/components/schemas/display_id"
          },
          "order_reference": {
            "$ref": "#/components/schemas/order_reference"
          },
          "metadata": {
            "$ref": "#/components/schemas/metadata_component"
          }
        }
      },
      "items": {
        "type": "array",
        "description": "A list of items.",
        "items": {
          "$ref": "#/components/schemas/item"
        }
      },
      "item": {
        "type": "object",
        "description": "An item with properties.",
        "required": [
          "reference",
          "name",
          "total_amount",
          "unit_price",
          "quantity"
        ],
        "properties": {
          "reference": {
            "$ref": "#/components/schemas/reference"
          },
          "name": {
            "$ref": "#/components/schemas/name_item"
          },
          "description": {
            "$ref": "#/components/schemas/item_description"
          },
          "options": {
            "$ref": "#/components/schemas/options"
          },
          "total_amount": {
            "$ref": "#/components/schemas/total_amount"
          },
          "unit_price": {
            "$ref": "#/components/schemas/unit_price"
          },
          "tax_amount": {
            "$ref": "#/components/schemas/amounts"
          },
          "quantity": {
            "$ref": "#/components/schemas/quantity"
          },
          "uom": {
            "type": "string",
            "examples": [
              "string"
            ]
          },
          "upc": {
            "type": "string",
            "examples": [
              "string"
            ]
          },
          "sku": {
            "$ref": "#/components/schemas/sku"
          },
          "isbn": {
            "$ref": "#/components/schemas/isbn"
          },
          "brand": {
            "$ref": "#/components/schemas/brand"
          },
          "manufacturer": {
            "$ref": "#/components/schemas/manufacturer"
          },
          "category": {
            "$ref": "#/components/schemas/category"
          },
          "collections": {
            "$ref": "#/components/schemas/collections"
          },
          "tags": {
            "$ref": "#/components/schemas/tag"
          },
          "color": {
            "$ref": "#/components/schemas/color"
          },
          "size": {
            "$ref": "#/components/schemas/size"
          },
          "weight": {
            "$ref": "#/components/schemas/total_weight"
          },
          "image_url": {
            "$ref": "#/components/schemas/image_url"
          },
          "details_url": {
            "type": "string",
            "description": "The URL for the item's details.",
            "examples": [
              "https://boltswagstore.com/inventory/hats/red-hat.png"
            ]
          },
          "type": {
            "$ref": "#/components/schemas/type"
          },
          "taxable": {
            "$ref": "#/components/schemas/taxable"
          },
          "properties": {
            "$ref": "#/components/schemas/item_properties"
          },
          "item_group": {
            "$ref": "#/components/schemas/item_group"
          },
          "shipment_type": {
            "$ref": "#/components/schemas/item_shipment_type"
          },
          "customizations": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "name",
                "price",
                "attributes"
              ],
              "properties": {
                "name": {
                  "$ref": "#/components/schemas/customizations_name"
                },
                "price": {
                  "$ref": "#/components/schemas/amounts"
                },
                "attributes": {
                  "$ref": "#/components/schemas/metadata_component"
                }
              }
            }
          },
          "bolt_product_id": {
            "$ref": "#/components/schemas/bolt_product_id"
          },
          "gift_options": {
            "$ref": "#/components/schemas/gift_options"
          }
        }
      },
      "reference": {
        "type": "string",
        "description": "Reference for the object.",
        "examples": [
          "1123"
        ]
      },
      "name_item": {
        "type": "string",
        "description": "The name of an item.",
        "examples": [
          "Blue Hat"
        ]
      },
      "item_description": {
        "type": "string",
        "description": "A description for the item added to the cart/order.",
        "examples": [
          " Large blue satin hat with initials embroidered."
        ]
      },
      "options": {
        "type": "string",
        "examples": [
          "string option"
        ]
      },
      "total_amount": {
        "type": "integer",
        "description": "The total amount.",
        "examples": [
          9900
        ]
      },
      "unit_price": {
        "type": "integer",
        "description": "Price per unit in cents.",
        "examples": [
          500
        ]
      },
      "amounts": {
        "type": "object",
        "description": "The amount. **Nullable** for Transactions Details.",
        "required": [
          "amount",
          "currency",
          "currency_symbol"
        ],
        "properties": {
          "amount": {
            "$ref": "#/components/schemas/amount"
          },
          "currency": {
            "$ref": "#/components/schemas/currency_iso"
          },
          "currency_symbol": {
            "$ref": "#/components/schemas/currency_symbol"
          }
        }
      },
      "amount": {
        "type": "integer",
        "description": "The amount in cents. **Nullable** for Transactions Details.",
        "examples": [
          754
        ]
      },
      "currency_iso": {
        "type": "string",
        "description": "The 3-digit ISO code for the currency. **Nullable** for Transactions Details.",
        "examples": [
          "USD"
        ]
      },
      "currency_symbol": {
        "type": "string",
        "description": "The currency symbol used for the amount. **Nullable** for Transactions Details.",
        "examples": [
          "$"
        ]
      },
      "quantity": {
        "type": "integer",
        "description": "The quantity of this item.",
        "examples": [
          3
        ]
      },
      "sku": {
        "type": "string",
        "description": "The SKU identifier for this item or service.",
        "examples": [
          "SKU-11021"
        ]
      },
      "isbn": {
        "type": "string",
        "description": "A 13-digit identifier for a book item.",
        "examples": [
          "12-345-678-90123"
        ]
      },
      "brand": {
        "type": "string",
        "description": "The name of a brand.",
        "examples": [
          "Bolt Swagstore"
        ]
      },
      "manufacturer": {
        "type": "string",
        "description": "The name of a manufacturer.",
        "examples": [
          "Bolt Factory"
        ]
      },
      "category": {
        "type": "string",
        "description": "A category.",
        "examples": [
          "hats"
        ]
      },
      "collections": {
        "type": "array",
        "items": {
          "$ref": "#/components/schemas/collection"
        }
      },
      "collection": {
        "type": "string",
        "examples": [
          "summer"
        ]
      },
      "tag": {
        "type": "string",
        "description": "A tag",
        "examples": [
          "red"
        ]
      },
      "color": {
        "type": "string",
        "description": "The color.",
        "examples": [
          "Red"
        ]
      },
      "size": {
        "type": "string",
        "description": "The size.",
        "examples": [
          "XXL"
        ]
      },
      "total_weight": {
        "type": "object",
        "properties": {
          "weight": {
            "$ref": "#/components/schemas/weight"
          },
          "unit": {
            "$ref": "#/components/schemas/weight_unit"
          }
        }
      },
      "weight": {
        "type": "integer",
        "description": "The weight of an item.",
        "examples": [
          22
        ]
      },
      "weight_unit": {
        "type": "string",
        "description": "The unit of measurement for an item's weight.",
        "examples": [
          "kg"
        ]
      },
      "image_url": {
        "type": "string",
        "description": "The URL for the item's image.",
        "examples": [
          "https://boltswagstore.com/inventory/hats/red-hat.png"
        ]
      },
      "type": {
        "type": "string",
        "enum": [
          "bundled",
          "digital",
          "physical",
          "unknown"
        ],
        "description": "Determines if item is a physical, digital, or bundled good, or if the good type is unknown.",
        "examples": [
          "physical"
        ]
      },
      "taxable": {
        "type": "boolean",
        "description": "Determines if item is taxable.",
        "examples": [
          true
        ]
      },
      "item_properties": {
        "type": "array",
        "items": {
          "$ref": "#/components/schemas/item_property"
        }
      },
      "item_property": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "a-name"
            ]
          },
          "value": {
            "type": "string",
            "examples": [
              "a-value"
            ]
          }
        }
      },
      "item_group": {
        "type": "string",
        "description": "Enables grouping in the checkout UI.",
        "examples": [
          "Ships Immediately"
        ]
      },
      "item_shipment_type": {
        "type": "string",
        "description": "The shipment type selected by the shopper.",
        "enum": [
          "unknown",
          "door delivery",
          "in_store_pickup",
          "ship_to_store"
        ]
      },
      "customizations_name": {
        "type": "string",
        "description": "The name of the customization.",
        "examples": [
          "Bedazzled"
        ]
      },
      "metadata_component": {
        "type": "object",
        "properties": {
          "key1": {
            "type": "string",
            "examples": [
              "value1"
            ]
          },
          "key2": {
            "type": "string",
            "examples": [
              "value2"
            ]
          }
        }
      },
      "bolt_product_id": {
        "type": "string",
        "description": "Unique ID generated for a product via the products endpoint.",
        "examples": [
          "e2bb0e7e-5625-536f-8ad7-25a26537ee28"
        ]
      },
      "gift_options": {
        "type": "object",
        "description": "Contains the gift option settings for wrapping and custom messages.",
        "required": [
          "wrap",
          "merchant_product_id"
        ],
        "properties": {
          "wrap": {
            "$ref": "#/components/schemas/gift_options_wrap"
          },
          "message": {
            "$ref": "#/components/schemas/gift_options_message"
          },
          "cost": {
            "$ref": "#/components/schemas/gift_options_cost"
          },
          "merchant_product_id": {
            "$ref": "#/components/schemas/merchant_product_id"
          }
        }
      },
      "gift_options_wrap": {
        "type": "boolean",
        "description": "Defines whether gift wrapping was requested.",
        "examples": [
          false
        ]
      },
      "gift_options_message": {
        "type": "string",
        "description": "Includes the gift message written by the shopper.",
        "examples": [
          "Happy Anniversary, Smoochy Poo!"
        ]
      },
      "gift_options_cost": {
        "type": "integer",
        "description": "Defines the price of gift wrapping this item. Required if `wrap` = `true`.\n",
        "examples": [
          785
        ]
      },
      "merchant_product_id": {
        "type": "string",
        "description": "The merchant's unique ID for the product.",
        "examples": [
          "881"
        ]
      },
      "display_id": {
        "type": "string",
        "description": "The displayed ID.",
        "examples": [
          "ID-12345"
        ]
      },
      "order_reference": {
        "type": "string",
        "description": "The order reference.",
        "examples": [
          "order-12345"
        ]
      },
      "request_source": {
        "type": "string",
        "description": "The source of the request.",
        "examples": [
          "checkout"
        ]
      },
      "shipping_option": {
        "type": "object",
        "description": "A shipping option.",
        "properties": {
          "service": {
            "$ref": "#/components/schemas/service"
          },
          "description": {
            "$ref": "#/components/schemas/shipping_option_description"
          },
          "cost": {
            "$ref": "#/components/schemas/cost"
          },
          "tax_amount": {
            "$ref": "#/components/schemas/tax_amount"
          },
          "reference": {
            "$ref": "#/components/schemas/reference"
          },
          "signature": {
            "$ref": "#/components/schemas/signature"
          },
          "estimated_delivery_date": {
            "$ref": "#/components/schemas/estimated_delivery_date"
          },
          "tax_code": {
            "$ref": "#/components/schemas/tax_code"
          },
          "discount_by_membership": {
            "$ref": "#/components/schemas/discount_membership"
          },
          "default": {
            "$ref": "#/components/schemas/shipping_default"
          },
          "description_tooltips": {
            "$ref": "#/components/schemas/shipping_option_description_tooltips"
          }
        }
      },
      "service": {
        "type": "string",
        "description": "The service name.",
        "examples": [
          "Option 1"
        ]
      },
      "shipping_option_description": {
        "type": "string",
        "description": "Additional information about the service. Supports a maximum of 60 characters and the use of `<span>`, with IDs to be used as tooltips.\n",
        "examples": [
          "The <span id=\"1\">most</span> popular choice"
        ]
      },
      "cost": {
        "type": "integer",
        "description": "The cost in cents.",
        "examples": [
          770
        ]
      },
      "tax_amount": {
        "type": "integer",
        "description": "Tax amount in cents.",
        "examples": [
          230
        ]
      },
      "signature": {
        "type": "string",
        "description": "The signature.",
        "examples": [
          "a1B2s3dC4f5g5D6hj6E7k8F9l0"
        ]
      },
      "estimated_delivery_date": {
        "type": "string",
        "description": "The estimated delivery date.",
        "examples": [
          "08-30-2022"
        ]
      },
      "tax_code": {
        "type": "string",
        "description": "The relevant tax code.",
        "examples": [
          "tax-12345"
        ]
      },
      "discount_membership": {
        "type": "boolean",
        "description": "Defines if shopper has a membership discount.",
        "examples": [
          false
        ]
      },
      "shipping_default": {
        "type": "boolean",
        "description": "Defines if option is default or not.",
        "examples": [
          true
        ]
      },
      "shipping_option_description_tooltips": {
        "type": "array",
        "description": "A list shipping tooltips.",
        "items": {
          "$ref": "#/components/schemas/shipping_option_description_tooltip"
        }
      },
      "shipping_option_description_tooltip": {
        "type": "object",
        "description": "An  <span id=\\\"1\\\">optional tooltip</span> for a shipping option that supports a maximum of 60 characters (does not include HTML). This tooltip is displayed beneath the shipping option.",
        "properties": {
          "target": {
            "$ref": "#/components/schemas/shipping_option_description_tooltip_target"
          },
          "html_content": {
            "$ref": "#/components/schemas/shipping_option_description_tooltip_content"
          }
        }
      },
      "shipping_option_description_tooltip_target": {
        "type": "integer",
        "description": "The ID of the span used to wrap the description's text. This ID is used to display the tooltip.",
        "examples": [
          1
        ]
      },
      "shipping_option_description_tooltip_content": {
        "type": "string",
        "description": "The HTML content that the tooltip displays. Supports up to 120 characters and the following HTML elements: `<i>`, `<b>`, `<br/>`, `<ul>`, `<li>`, and `<a href=\"...\">`\n",
        "examples": [
          "Timeline may vary depending on <b>location</b>."
        ]
      },
      "pickup_option": {
        "type": "object",
        "description": "A pickup option.",
        "properties": {
          "reference": {
            "$ref": "#/components/schemas/reference"
          },
          "signature": {
            "$ref": "#/components/schemas/signature"
          },
          "cost": {
            "$ref": "#/components/schemas/cost"
          },
          "tax_amount": {
            "$ref": "#/components/schemas/tax_amount"
          },
          "store_name": {
            "$ref": "#/components/schemas/name_store"
          },
          "pickup_window_open": {
            "$ref": "#/components/schemas/pickup_window_open"
          },
          "pickup_window_close": {
            "$ref": "#/components/schemas/pickup_window_close"
          },
          "address": {
            "$ref": "#/components/schemas/pickup_address"
          },
          "distance": {
            "$ref": "#/components/schemas/distance"
          },
          "distance_unit": {
            "$ref": "#/components/schemas/distance_unit"
          }
        }
      },
      "name_store": {
        "type": "string",
        "description": "The name of the store.",
        "examples": [
          "Bolt Swag Store #47"
        ]
      },
      "pickup_window_open": {
        "type": "integer",
        "description": "When a store is available for picking up orders.",
        "examples": [
          1578904185
        ]
      },
      "pickup_window_close": {
        "type": "integer",
        "description": "When a store not available for picking up orders.",
        "examples": [
          1578904185
        ]
      },
      "pickup_address": {
        "type": "object",
        "properties": {
          "street_address1": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address2": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address3": {
            "$ref": "#/components/schemas/street_address"
          },
          "street_address4": {
            "$ref": "#/components/schemas/street_address"
          },
          "locality": {
            "$ref": "#/components/schemas/locality"
          },
          "region": {
            "$ref": "#/components/schemas/region"
          },
          "postal_code": {
            "$ref": "#/components/schemas/postal_code"
          },
          "country_code": {
            "$ref": "#/components/schemas/country_code"
          },
          "country": {
            "$ref": "#/components/schemas/country"
          }
        }
      },
      "distance": {
        "type": "integer",
        "description": "The distance as a number.",
        "examples": [
          2
        ]
      },
      "distance_unit": {
        "type": "string",
        "description": "The distance unit.",
        "examples": [
          "miles"
        ]
      },
      "shipping_to_store_option": {
        "type": "object",
        "description": "A shipping option.",
        "properties": {
          "service": {
            "$ref": "#/components/schemas/service"
          },
          "reference": {
            "$ref": "#/components/schemas/reference"
          },
          "signature": {
            "$ref": "#/components/schemas/reference"
          },
          "cost": {
            "$ref": "#/components/schemas/cost"
          },
          "tax_amount": {
            "$ref": "#/components/schemas/tax_amount"
          },
          "store_name": {
            "$ref": "#/components/schemas/name_store"
          },
          "address": {
            "$ref": "#/components/schemas/shipping_address"
          },
          "distance": {
            "$ref": "#/components/schemas/distance"
          },
          "distance_unit": {
            "$ref": "#/components/schemas/distance_unit"
          }
        }
      },
      "shipping_options": {
        "type": "array",
        "description": "A list of shipping options.",
        "items": {
          "$ref": "#/components/schemas/shipping_option"
        }
      },
      "pickup_options": {
        "type": "array",
        "description": "A list of pickup options.",
        "items": {
          "$ref": "#/components/schemas/pickup_option"
        }
      },
      "tax_result": {
        "type": "object",
        "properties": {
          "items": {
            "$ref": "#/components/schemas/items"
          },
          "rate_subtotal": {
            "$ref": "#/components/schemas/rate_subtotal"
          },
          "rate_shipping": {
            "$ref": "#/components/schemas/rate_shipping"
          },
          "subtotal_amount": {
            "$ref": "#/components/schemas/amount"
          }
        }
      },
      "rate_subtotal": {
        "type": "integer",
        "description": "The rate subtotal in cents.",
        "examples": [
          300
        ]
      },
      "rate_shipping": {
        "type": "integer",
        "description": "The shipping rate amount in cents.",
        "examples": [
          234
        ]
      },
      "error": {
        "type": "object",
        "properties": {
          "code": {
            "$ref": "#/components/schemas/code"
          },
          "data": {
            "$ref": "#/components/schemas/reasons"
          }
        }
      },
      "code": {
        "type": "integer",
        "format": "int64",
        "description": "This is an error code.",
        "examples": [
          2001005
        ]
      },
      "reasons": {
        "type": "array",
        "items": {
          "$ref": "#/components/schemas/reason"
        }
      },
      "reason": {
        "type": "object",
        "description": "The reason for the error.",
        "properties": {
          "reason": {
            "type": "string",
            "examples": [
              "This product is out of stock."
            ]
          }
        }
      }
    },
    "responses": {
      "order_shipping_and_tax": {
        "description": "Shipping and Tax Response",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "required": [
                "event",
                "status",
                "data"
              ],
              "properties": {
                "event": {
                  "type": "string",
                  "enum": [
                    "order.shipping_and_tax"
                  ]
                },
                "status": {
                  "type": "string",
                  "enum": [
                    "success"
                  ]
                },
                "data": {
                  "type": "object",
                  "description": "This is a generic wrapper for the merchant API’s request body.",
                  "properties": {
                    "shipping_options": {
                      "$ref": "#/components/schemas/shipping_options"
                    },
                    "pickup_options": {
                      "$ref": "#/components/schemas/pickup_options"
                    },
                    "ship_to_store_options": {
                      "$ref": "#/components/schemas/shipping_options"
                    },
                    "tax_result": {
                      "$ref": "#/components/schemas/tax_result"
                    },
                    "metadata": {
                      "$ref": "#/components/schemas/metadata_component"
                    }
                  }
                }
              }
            }
          }
        }
      },
      "order_shipping_and_tax_error": {
        "description": "Shipping and Tax Calculations Failed",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "event": {
                  "type": "string",
                  "enum": [
                    "order.order_shipping_and_tax"
                  ]
                },
                "status": {
                  "type": "string",
                  "enum": [
                    "failure"
                  ]
                },
                "error": {
                  "$ref": "#/components/schemas/error"
                }
              }
            }
          }
        }
      }
    },
    "securitySchemes": {
      "ApiKeyAuth": {
        "type": "apiKey",
        "in": "header",
        "name": "X-API-Key",
        "description": "Admins and Developers can obtain their Bolt API key from the Bolt Merchant Dashboard."
      }
    }
  }
}
```
